/*
 * Hedgewars, a free turn based strategy game
 * Copyright (c) 2009 Kristian Lehmann <email@thexception.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef TOGGLEBUTTONWIDGET_H
#define TOGGLEBUTTONWIDGET_H

#include <QWidget>
#include <QPainter>
#include <QPushButton>
#include <QVBoxLayout>
#include <QLabel>

class ToggleButtonWidget : public QPushButton
{
    Q_OBJECT
public:
    ToggleButtonWidget(QWidget * parent, QString img);
    ~ToggleButtonWidget();
private:
    QPixmap pmChecked;
    QPixmap pmDisabled;
private slots:
    void eventToggled(bool checked);
};

#endif // TOGGLEBUTTONWIDGET_H
